// Adapted from Dan Shiffman' Thing Class
class Cloud {
  PVector loc;
  PVector vel;
  PVector acc;
  float max_vel;
  float w, h;
  int vaporDensity;
  float theta;
  
  ArrayList vapors;
  Random gaussianRandom;
      
  
  Cloud(PVector l, float _w, float _h, int _vaporDensity) {
    w = _w;
    h = _h;
    
    acc = new PVector(0, 0);
    vel = new PVector(0, 0);
    
    max_vel = 5;
    
    theta = 0;
    
    vaporDensity = _vaporDensity;
    vapors = new ArrayList();
    
    loc = l.get();
    
    gaussianRandom = new Random();    
    
    while(vapors.size() < vaporDensity) {
      
      float tempW = (float)gaussianRandom.nextGaussian() * (w / 6);
      float tempH = (float)gaussianRandom.nextGaussian() * (h / 6);
      
      tempW = random(0, w);
      tempH = random(0, h);      
      
      vapors.add(new Vapor(new PVector(tempW, tempH)));
    }
    
    
  }

  // Main method to operate object
  void tick() {
    update();
    render();
  }
  
  // Method to update location
  void update() {
    vel.add(acc);
    vel.limit(max_vel);
    loc.add(vel);
    //acc.mult(0);
    theta += random(0, 0.02);
    
    
  }
  
  // Method to display
  void render() {

    pushMatrix();
    translate(loc.x, loc.y + sin(theta) * 4);
    for(int i = 0; i < vapors.size(); i++) {
      Vapor vapor = (Vapor) vapors.get(i);

      vapor.tick();

    }
    popMatrix();

  }
}
